<template>
  <component
    :is="props.integration.connectComponent"
    v-if="props.integration.connectComponent"
    :integration="props.integration"
  >
    <template
      #default="{
        connect,
        settings,
        hasSettings,
        hasIntegration,
      }"
    >
      <slot
        :connect="connect"
        :settings="settings"
        :has-settings="hasSettings"
        :has-integration="hasIntegration"
        :connected="isConnected"
        :done="isDone"
      />
    </template>
  </component>
  <div v-else class="flex items-center justify-between">
    <a
      v-if="props.integration.platform === 'custom'"
      href="https://docs.getsphere.dev/technical-docs/custom-integration/"
      target="_blank"
      rel="noopener noreferrer"
      class="btn btn-brand btn-brand--primary btn--md"
    >Read more</a>
    <component
      :is="props.integration.connectComponent"
      v-else-if="props.integration.connectComponent"
      :integration="props.integration"
    />
    <a
      class="btn btn--secondary btn--md"
      href="mailto:support@liscioapps.com"
    >
      Get in touch
    </a>
  </div>

  <app-dialog
    v-model="isCalDialogOpen"
    size="2extra-large"
  >
    <template #content>
      <div
        id="embbeded-script"
        class="w-full px-3 pb-3 min-h-20"
      />
    </template>
  </app-dialog>
</template>

<script setup>
import { defineProps, computed, ref } from 'vue';

const props = defineProps({
  integration: {
    type: Object,
    required: true,
    default: () => ({}),
  },
});

const isCalDialogOpen = ref();

const isConnected = computed(() => props.integration.status !== undefined);

const isDone = computed(() => props.integration.status === 'done');
</script>

<script>
export default {
  name: 'AppIntegrationConnect',
};
</script>
